class El {
  constructor(el, modules) {
    this.el = el.parentNode.parentNode;
    this.modules = modules;
    this.el.addEventListener('mouseenter', () => this._mouseenter());
    this.el.addEventListener('mouseleave', () => this._mouseleave());
  }
  _mouseenter() {
    this.modules._enter();
  }
  _mouseleave() {
    this.modules._leave();
  }
}

export default class {
  constructor(imageList) {
    this._page = { x: 0, y: 0 };
    this.page = { x: 0, y: 0 };
    this.imageList = imageList;
    this.circle = document.querySelector('.js-circle');

    this.imageList = [...imageList].map(x => new El(x, this));

    window.addEventListener('mousemove', (e) => this._mousemove(e));
    requestAnimationFrame(this._render.bind(this));
  }

  _mousemove(e) {
    this._page.x = e.pageX;
    this._page.y = e.pageY;
  }

  _enter() {
    this.circle.classList.add('is-active');
  }

  _leave() {
    this.circle.classList.remove('is-active');
  }

  _render() {
    this.page.x += (this._page.x - this.page.x) * 0.2;
    this.page.y += (this._page.y - this.page.y) * 0.2;
    this.circle.style.left = `${this.page.x}px`;
    this.circle.style.top = `${this.page.y}px`;
    requestAnimationFrame(this._render.bind(this));
  }
}
