import gsap from 'gsap';

const _remove = ($svg) => {
  gsap.to($svg, {
    translateX: '-100%',
    ease: 'power4.inOut',
    duration: 1.4,
  });
  gsap.to($svg.children[0], {
    translateX: '100%',
    ease: 'power4.inOut',
    duration: 1.4,
    onComplete: () => {
      gsap.set($svg, { display: 'none' });
    }
  });
}

export default function($svg, $circle, $num) {
  const l = $circle.getTotalLength();

  gsap.set($svg.children[0], { opacity: 1 });
  gsap.set($circle, {
    strokeDasharray: l,
    strokeDashoffset: l
  });
  const tween = gsap.to($circle, {
    strokeDashoffset: 0,
    ease: 'power4.inOut',
    delay: 0.3,
    duration: 3,
    onUpdate: () => {
      const num = Math.round(tween.progress() * 100);
      $num.textContent = num;
    },
    onComplete: () => _remove($svg)
  });
}
